%define module  zfs
%define kmod_name zfs
%define kernel_version 2.6.32-358.2.1.el6.%{_target_cpu}
%bcond_with     debug
%bcond_with     debug_dmu_tx


Name:           %{module}-kmod

Version:        0.6.1
Release:        1%{?dist}.2
Summary:        Kernel module(s)

Group:         System Environment/Kernel
License:       CDDL
URL:		http://zfsonlinux.org/
Source0:        %{module}-%{version}.tar.gz
Patch1:		sizefix.patch
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# The developments headers will conflict with the dkms packages.
Conflicts:      %{module}-dkms

# needed for plague to make sure it builds for i586 and i686
ExclusiveArch:  i686 x86_64

BuildRequires: spl-kmod-devel
BuildRequires: kernel-devel = 2.6.32-358.2.1.el6
BuildRequires: kabi-whitelists %kernel_module_package_buildreqs
%kernel_module_package -n %{kmod_name}

%description
This package contains the ZFS kernel modules.

%package devel
Summary:	ZFS File System Headers and Symbols
Group:		Development/Libraries
Requires:	kernel-devel%{_isa} = %kverrel

%description devel
The %{name}-devel package contains the header files and Module{s}.symvers
symbols needed for building additional modules which use %{name}.

%prep
%setup -q -c -T -a 0
%patch1 -p0

%if %{with debug}
    %define debug --enable-debug
%else
    %define debug --disable-debug
%endif

%if %{with debug_dmu_tx}
    %define debug_dmu_tx --enable-debug-dmu-tx
%else
    %define debug_dmu_tx --disable-debug-dmu-tx
%endif

for flavor in %flavors_to_build ; do
%ifarch %{ix86}
    cp -a zfs-%{version} _kmod_build_${flavor}
%else
    cp -a zfs-%{version} _kmod_build_${flavor}
%endif
done

%build
for flavor in %flavors_to_build ; do
	pushd _kmod_build_${flavor}
	%configure --with-config=kernel \
		--with-linux=%{kernel_source $flavor} --with-linux-obj=%{kernel_source $flavor} \
		--with-spl=/usr/src/spl-%{version} \
		--with-spl-obj=/usr/src/spl-%{version}/%kverrel${flavor%default}
	make
	popd
done

%install
rm -rf $RPM_BUILD_ROOT
for flavor in %flavors_to_build ; do
	#/lib/modules/%kverrel${flavor%default}/extra/zfs
	make -C _kmod_build_${flavor} DESTDIR=$RPM_BUILD_ROOT install
	pushd $RPM_BUILD_ROOT/lib/modules/%kverrel${flavor%default}
	mv extra/zfs .
	find extra
	mv extra/*/*ko zfs/
	rmdir extra/*
	mv zfs extra/
	popd
    #install -D -m 0755 _kmod_build_${flavor}/kernel/nvidia.ko $RPM_BUILD_ROOT/lib/modules/%kverrel${flavor%default}/extra/nvidia/nvidia.ko
done

%clean
rm -rf $RPM_BUILD_ROOT

%files devel
%defattr(-,root,root)
%{_prefix}/src/*/*

%changelog
* Fri Sep 14 2012 Josko Plazonic <plazonic@math.princeton.edu>
- initial build
